#ifndef RAWTEXTURE_H
#define RAWTEXTURE_H

#include "texturecommon.h"

class RawTexture : public TextureCommon
{
public:
	RawTexture();
	virtual ~RawTexture();

	virtual void* GetHandle();

	void Initialize( uint Width, uint Height );
	void Initialize( const char* const Filename ) { TextureCommon::Initialize( Filename ); }

	void Save( const char* const Filename );
	void Save( const IDataStream &Stream );

	void CopyRect( RawTexture &From, uint FromX, uint FromY, uint Width, uint Height, uint ToX, uint ToY );

	void SetPixel( uint X, uint Y, uint8 R, uint8 G, uint8 B, uint8 A );
	bool GetPixel( uint X, uint Y, uint8 &R, uint8 &G, uint8 &B, uint8 &A );
protected:
	byte *m_ARGBImage;

	void			SavePNG( const IDataStream& Stream, int Width, int Height, byte* ARGBImage );

	virtual void	CreateTexture( byte* const ARGBImage );
	virtual void	CreateTextureFromDDS( const IDataStream& Stream );
};

#endif // RAWTEXTURE_H
