#include "core.h"
#include "simplestring.h"
#include "system.h"

#if BUILD_WINDOWS
#include <windows.h>
#else
#include <unistd.h>
#include <sys/types.h>
#include <pwd.h>
#endif

#include <errno.h>
#include <string.h>

SimpleString System::GetUsername()
{
	int len = 256;
	char Username[len];
#if BUILD_WINDOWS
	DWORD wlen = len;
	if( GetUserName( Username, &wlen ) )
	{
		return Username;
	}
#else
	if( getlogin_r( Username, len ) == 0 )
	{
		return Username;
	}
	uid_t MyUid = getuid();
	struct passwd *pPwEntry = getpwuid( MyUid );
	if( pPwEntry )
	{
		return pPwEntry->pw_name;
	}
#endif
	return "";
}
