#include "core.h"
#include "uiscreen-eldleaderboards.h"
#include "Actions/wbactioneldpostscore.h"
#include "configmanager.h"

UIScreenEldLeaderboards::UIScreenEldLeaderboards()
:	m_Board( NULL )
,	m_NumEntries( 0 )
{
}

/* virtual */ UIScreenEldLeaderboards::~UIScreenEldLeaderboards()
{
}

void UIScreenEldLeaderboards::InitializeFromDefinition( const SimpleString& DefinitionName )
{
	UIScreen::InitializeFromDefinition( DefinitionName );

	//UIWidgetText* pHeader = static_cast< UIWidgetText* >( m_RenderWidgets[1] );
	//UIWidgetText* pBack = static_cast< UIWidgetText* >( m_RenderWidgets[2] );
	m_Board = static_cast< UIWidgetList* >( m_RenderWidgets[3] );

	// should this be in the config files somewhere? Probably...
	ConfigManager::SetString( "Header", "LeaderboardsHeader", "Leaderboards" );

	STATICHASH( NumEntries );
	m_NumEntries = ConfigManager::GetInt( sNumEntries, 10,  DefinitionName );

	FillLeaderboards( "LB_Souls" );
}

void UIScreenEldLeaderboards::FillLeaderboards( const SimpleString& Tag )
{
	VarMap ScoreMap;
	WBActionEldPostScore::LoadScore( ScoreMap );

	SimpleString NamePattern = Tag + "%dName";
	SimpleString ScorePattern = Tag + "%dScore";

	uint i = 0;
	bool done = false;
	m_Board->AddEntry( "Rank Name                          Score" );
	while( !done && i < m_NumEntries )
	{
		const char *Name = ScoreMap.GetString( SimpleString::PrintF( NamePattern, i ), NULL );
		if( !Name )
		{
			done = true;
			continue;
		}
		int Score = ScoreMap.GetInt( SimpleString::PrintF( ScorePattern, i ), 0 );
		m_Board->AddEntry( SimpleString::PrintF("%4d %-29s %5d", i + 1, Name, Score ) );
		++i;
	}

}
